from dataclasses import dataclass


@dataclass
class Folders:
    data: str


@dataclass
class Parameters:
    filter: str


@dataclass
class OTilsConfig:
    """pass"""
    folders: Folders
    parameters: Parameters


def get_configuration():
    import yaml
    import os
    configuration_file = "conf/configuration.yaml"
    dirname = os.path.dirname(__file__)
    configuration_path = os.path.join(dirname, configuration_file)

    with open(configuration_path, "r") as f:
        configuration = yaml.safe_load(f)
    # Create folders object with the information from the configuration file
    folders = Folders(data=configuration["folders"]["data"])
    # Create parameters object ...
    parameters = Parameters(filter=configuration["parameters"]["filter"])
    # Create configuration object
    conf = OTilsConfig(folders=folders, parameters=parameters)

    return conf


# Initialize configuration
configuration = get_configuration()


if __name__ == "__main__":
    conf = get_configuration()

    print(conf)
    print(conf.folders)
    print(conf.folders.data)